#ifndef __palette_h__
#define __palette_h__

#define MAX_COLOUR 64
#define ASSERT_PALETTE_NUM(A) if(A < 0 || A >= MAX_COLOUR) return;

//the colour palette for visual objects:
struct _palette {
  guint red[MAX_COLOUR];
  guint blu[MAX_COLOUR];
  guint grn[MAX_COLOUR];
};

void            am_palette_load          (Palette*);
void            palette_set_style_colours(Palette*, GtkStyle*);
void            palette_lookup           (Palette*, GdkColor*, int c_idx);
uint32_t        palette_get_rgba         (Palette*, int c_idx, unsigned char alpha);
void            palette_get_float        (Palette*, int c_idx, float* r, float* g, float* b, const unsigned char alpha);
uint32_t        am_colour_get_contrasting(Palette*, int c_idx);

void            am_rgba_to_float         (uint32_t rgba, float* r, float* g, float* b);
void            colour_get_style_base    (GdkColor*, int state);
void            colour_get_style_bg_     (GdkColor*, int state);
void            colour_get_style_fg      (GdkColor*, int state);
void            colour_get_rgba_str      (char* colorstr, int c_idx, const unsigned char alpha);
void            colour_get_rgb_str       (char* colorstr, int c_idx);

#endif //__palette_h__
