#ifndef __model_pool_h__
#define __model_pool_h__
#include <model/am_collection.h>
#include <model/am_peak.h>
#include <model/am_pool_item.h>
#define POOL_ITEM_IS_OK(A) (A && A->state == POOL_ITEM_OK)
#define REGION_FULL 0x0fffffff      //a magic region_index number indicating a region representing the whole audio file.
                                    //warning! this is dangerous!
#define am_pool__iter_init(I) model_collection_iter_init((ModelCollection*)song->pool, I);
#define am_pool__emit(...) ({ if(song->loaded) g_signal_emit_by_name (song->pool, __VA_ARGS__); })
#define am_pool ((ModelCollection*)song->pool)

void        am_pool__init                   ();
void        am_pool__free                   ();
void        am_pool__sync                   ();
void        am_pool__add                    (PoolItem*);
//#ifdef __am_private__
PoolItem*   am_pool__add_from_file          (const char* fname);
//#endif
PoolItem*   am_pool__add_ayyi_file          (AyyiFilesource*);
bool        am_pool__remove                 (PoolItem*);
void        am_pool__clear                  ();
bool        am_pool__item_exists            (char* fname);
#ifdef __am_private__
PoolItem* am_pool__find_pending_by_leafname (const char*);
#endif
PoolItem*   am_pool__get_item_from_idx      (AyyiIdx);
PoolItem*   am_pool__get_item_from_leafname (const char*);
PoolItem*   am_pool__get_item_by_orig_name  (const char*);
GList*      am_pool__get_new_items          ();
PoolItem*   am_pool__get_item_by_id         (AyyiId);

void        am_pool__print                  ();

#endif //__model_pool_h__
